package hep.wired.heprep.interaction;

import hep.graphics.heprep.HepRepAttributeListener;
import hep.graphics.heprep.HepRepInstance;
import hep.graphics.heprep.HepRepIterator;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.freehep.util.Value;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: CutData.java 13862 2011-07-21 00:43:34Z onoprien $
 */
public class CutData implements HepRepAttributeListener {

    private Map /*<String, Value>*/data;
    private boolean changed;
    
    public CutData() {
        data = new HashMap(10);
        changed = true; // NOTE: better to make sure the first time we evaluate.
    }
    
    public void setAttribute(HepRepInstance instance, String name, String value, String lowerCaseValue, int showLabel) {
        getValue(name).set(value);
        changed = true;
    }

    public void setAttribute(HepRepInstance instance, String name, Color value, int showLabel) {
        getValue(name).set(value);
        changed = true;
    }

    public void setAttribute(HepRepInstance instance, String name, long value, int showLabel) {
        getValue(name).set(value);
        changed = true;
    }

    public void setAttribute(HepRepInstance instance, String name, int value, int showLabel) {
        getValue(name).set(value);
        changed = true;
    }

    public void setAttribute(HepRepInstance instance, String name, double value, int showLabel) {
//        if (name.equals("ch")) {
//          System.out.println("");
//          System.out.println("Att: "+ value +" + "+ (instance.getAttValueFromNode(name) == null ? ("T: "+instance.getAttValue(name)) : instance.getAttValueFromNode(name)));
//        }
      getValue(name).set(value);
      changed = true;
    }

    public void setAttribute(HepRepInstance instance, String name, boolean value, int showLabel) {
        getValue(name).set(value);
        changed = true;
    }

    public void removeAttribute(HepRepInstance instance, String name) {
        getValue(name).set((Object)null);
        changed = true;
    }

    public Map getData() {
        return data;
    }

    private Value getValue(String name) {
        Value value = (Value)data.get(name);
        if (value == null) {
            value = new Value();
            data.put(name, value);
        }
        return value;
    }
 
    public void subscribeTo(HepRepIterator iterator, Set<String> conditionNames) {
      for (String name : conditionNames) {
        iterator.addHepRepAttributeListener(name, this);
      }
    }
        
    /** Returns <tt>true</tt> if any attributes have changed (or were removed) since the last call to this method. */
    public boolean hasChanged() {
        if (changed) {
            changed = false;
            return true;
        }
        return false;
    }
}
