// Copyright 2004, FreeHEP.
package hep.wired.heprep.interaction;

/**
 * Flag, a name/boolean pair.
 * 
 * @author Mark Donszelmann
 * @version $Id: Flag.java 8598 2006-08-14 20:38:02Z duns $
 */
public class Flag {
    public static final int NAME = 0;

    public static final int FLAG = 1;

    private String name;

    private boolean flag;

    public Flag(String name, boolean flag) {
        this.name = name;
        this.flag = flag;
    }

    public String getName() {
        return name;
    }

    public boolean isSet() {
        return flag;
    }

    public void set(boolean state) {
        flag = state;
    }

    public int hashCode() {
        return name.hashCode();
    }

    public boolean equals(Object obj) {
        if (obj instanceof Flag) {
            return name.equals(((Flag) obj).getName());
        }
        return super.equals(obj);
    }

    public String toString() {
        return "Flag: " + getName() + " " + isSet() + " " + hashCode();
    }
}
