// Copyright 2004-2006, FreeHEP.
package hep.wired.heprep.interaction;

import hep.wired.heprep.graphicspanel.ControlPanel;
import hep.wired.heprep.plugin.WiredPlugin;
import hep.wired.image.WiredBaseImage;
import hep.wired.services.InteractionHandler;

import javax.swing.Icon;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: Picking.java 13827 2011-05-05 03:08:47Z onoprien $
 */
public class Picking extends RoutingInteractionHandler {

    private static Picking instance;

    private HepRepInfoPanel panel;

    private Picking() {
        super("Pick");
        panel = new HepRepInfoPanel();

        InteractionHandler hoverToPick = WiredPlugin.IH.PICK_HOVER.get();
//        InteractionHandler hoverToPick = new HoverToPick();
        add(hoverToPick, true);
        panel.addHandler(hoverToPick, true);

        // FIXME, NPE when this is not called.
        panel.setInteractionHandler(hoverToPick);

        InteractionHandler dragRectangleToPick = WiredPlugin.IH.PICK_RECTANGLE.get();
//        InteractionHandler dragRectangleToPick = new DragRectangleToPick();
        add(dragRectangleToPick, false);
        panel.addHandler(dragRectangleToPick, false);

        panel.addHandler(null, false);
    }

    public static Picking getInstance() {
        if (instance == null) {
            instance = new Picking();
        }
        return instance;
    }

    public Icon getIcon(int size) {
        return WiredBaseImage.getIcon("PickInfo%w", size);
    }

    public String getDescription() {
        return "Picking of Objects.";
    }

    public ControlPanel getPanel() {
        return panel;
    }

    public String toString() {
        return "Picking";
    }
}
