// Copyright 2004-2006, FreeHEP.
package hep.wired.heprep.interaction;

import hep.wired.heprep.plugin.WiredPlugin;
import hep.wired.image.WiredBaseImage;
import hep.wired.interaction.DefaultInteractionHandler;

import java.awt.Component;

import javax.swing.Icon;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: TreeSelection.java 8598 2006-08-14 20:38:02Z duns $
 */
public class TreeSelection extends RoutingInteractionHandler {

    private static TreeSelection instance;

    private TreeSelection() {
        super("Visibility Tree");
        add(DefaultInteractionHandler.getInstance());
    }

    public static TreeSelection getInstance() {
        if (instance == null) {
            instance = new TreeSelection();
        }
        return instance;
    }

    public Icon getIcon(int size) {
        return WiredBaseImage.getIcon("Tree%w", size);
    }

    public String getDescription() {
        return "Selection of visibility of types.";
    }

    public Component getControl() {
        return WiredPlugin.getPlugin().getTreePanel();
    }

    public String toString() {
        return "TreeSelection";
    }
}
