// Copyright 2004-2006, FreeHEP.
package hep.wired.heprep.projection;

import hep.wired.heprep.services.InverseProjection;
import hep.wired.heprep.services.Projection;

/**
 * Dummy projection which changes nothing.
 * 
 * @author Mark Donszelmann
 * @version $Id: NullProjection.java 8598 2006-08-14 20:38:02Z duns $
 */

public class NullProjection extends AbstractProjection implements InverseProjection {

    /**
     * Creates a null projection.
     */
    public NullProjection() {
        super();
    }

    public String getFormula() {
        return "(u,v,w) = Identity(x,y,z)";
    }

    public double[] transform(double[] xyz) {
        return xyz;
    }

    public double[][] transform(double[][] xyz, int n) {
        return xyz;
    }

    public double[] deltaTransform(double[] xyz) {
        return xyz;
    }

    public double[] inverseTransform(double[] uvw)
            throws UnsupportedOperationException {
        return uvw;
    }

    public double[] inverseDeltaTransform(double[] uvw)
            throws UnsupportedOperationException {
        return uvw;
    }

    public Projection copy() {
        return new NullProjection();
    }
}
