// Copyright 2004-2005, FreeHEP.
package hep.wired.heprep.representation;

import hep.graphics.heprep.HepRepInstance;
import hep.graphics.heprep.HepRepPoint;
import hep.wired.heprep.services.DrawAs;

import java.util.Iterator;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: AbstractDrawAs.java 8598 2006-08-14 20:38:02Z duns $
 */

public abstract class AbstractDrawAs implements DrawAs {

    public String getID() {
        return getName();
    }

    protected int fillArray(double[][] uvw, HepRepInstance instance) {
        int n = instance.getPoints(uvw);
        if (n == -1) {
            n = 0;
            for (Iterator i = instance.getPoints().iterator(); i.hasNext();) {
                HepRepPoint p = (HepRepPoint) i.next();
                uvw[U][n] = p.getX();
                uvw[V][n] = p.getY();
                uvw[W][n] = p.getZ();
                n++;
            }
        } else if (n < -1) {
            try {
                instance.addAttValue("_wired.skipped.points", -n
                        - uvw[U].length);
            } catch (RuntimeException e) {
                // ignored for non-implementers
            }
            // we skip points, and use the array as is
            n = uvw[U].length;
        }
        return n;
    }
}
