// Copyright 2004, FreeHEP.
package hep.wired.heprep.representation;

import hep.wired.heprep.services.DrawAs;
import hep.wired.util.WiredRegistry;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * Cache to register and lookup "DrawAs" values.
 * 
 * @author Mark Donszelmann
 * @version $Id: DrawAsCache.java 8598 2006-08-14 20:38:02Z duns $
 */

public class DrawAsCache {

    private transient Map /* <String,DrawAs> */drawAs;

    public DrawAs lookup(String name) {
        if (drawAs == null) {
            // cache all, since lookups on ID would take too much time
            Collection instances = WiredRegistry.allInstances(DrawAs.class);
            drawAs = new HashMap(instances.size());
            for (Iterator i = instances.iterator(); i.hasNext();) {
                DrawAs value = (DrawAs) i.next();
                drawAs.put(value.getKey(), value);
            }
        }
        return (DrawAs) drawAs.get(name);
    }
}
