// Copyright 2003-2004, FreeHEP.
package hep.wired.heprep.services;

import java.awt.Color;

/**
 * Interface for subscribed attributes
 * 
 * @author Mark Donszelmann
 * @version $Id: Attributes.java 8598 2006-08-14 20:38:02Z duns $
 */

public interface Attributes {

    public static final int ARROW_NONE = 0;

    public static final int ARROW_START = 1;

    public static final int ARROW_END = 2;

    public static final int ARROW_BOTH = 3;

    /**
     * Current DrawAs value
     */
    public String getDrawAs();

    /**
     * Current color
     */
    public Color getColor();

    /**
     * Current line width
     */
    public double getLineWidth();

    /**
     * Current line has arrow
     */
    public int hasLineArrow();

    /**
     * Current frame color
     */
    public Color getFrameColor();

    /**
     * Current frame line width
     */
    public double getFrameWidth();

    /**
     * Current fill color
     */
    public Color getFillColor();

    /**
     * Should fill ?
     */
    public boolean isFilled();

    /**
     * Current marker symbol
     */
    public int getMarkSymbol();

    /**
     * Current marker size
     */
    public double getMarkSize();

    /**
     * Subscribe these attributes to the given iterator.
     */
    // public void subscribeTo(HepRepIterator iterator);
}
