// Copyright 2004-2005, FreeHEP.
package hep.wired.heprep.services;

import hep.graphics.heprep.HepRepInstance;
import hep.wired.services.ViewPort;
import hep.wired.util.UVWindices;
import hep.wired.util.WiredRegistry;
import hep.wired.util.XYZindices;

import org.freehep.graphics2d.VectorGraphics;

/**
 * Converts a HepRepInstance (and its attributes and HepRepPoints) into a visual
 * representation on the plot.
 * 
 * @author Mark Donszelmann
 * @version $Id: DrawAs.java 8598 2006-08-14 20:38:02Z duns $
 */

public interface DrawAs extends WiredRegistry.ID, XYZindices, UVWindices {

    /**
     * Returns DrawAs key
     */
    public String getKey();

    /**
     * Returns a short name.
     */
    public String getName();

    /**
     * Describes what this DrawAs value does.
     */
    public String getDescription();

    /**
     * Draws an HepRepInstance into VectorGraphics using given Attributes. Color
     * and LineWidth are already set correctly for drawing. The attribute "fill"
     * should be checked if filling applies.
     */
    public void draw(VectorGraphics graphics, HepRepInstance instance,
            Attributes atts, GraphicsMode mode, Projection projection,
            ViewPort viewPort);

    /**
     * Draws a frame of an HepRepInstance into VectorGraphics using given
     * Attributes. Color and LineWidth are NOT set.
     */
    public void frame(VectorGraphics graphics, HepRepInstance instance,
            Attributes atts, GraphicsMode mode, Projection projection,
            ViewPort viewPort);
}
