// Copyright 2006, FreeHEP.
package hep.wired.heprep.services;


/**
 * Transforms coordinates in one system (X', Y', Z') into coordinates of the original
 * system (X, Y, Z).
 * 
 * @author Mark Donszelmann
 * @version $Id: InverseProjection.java 8598 2006-08-14 20:38:02Z duns $
 * @since 4.1
 */

public interface InverseProjection extends Projection {

    /**
     * Returns an array of length 3: xyz = inverse projection(uvw). The returned
     * array may have a lifetime up to the next call to this method on this
     * object. UnsupportedOperation is thrown in no inverse projection is
     * possible.
     */
    public double[] inverseTransform(double[] uvw)
            throws UnsupportedOperationException;

    /**
     * Returns an array of length 3: xyz = inverse delta projection(uvw). The
     * returned array may have a lifetime up to the next call to this method on
     * this object. UnsupportedOperation is thrown in no inverse delta
     * projection is possible.
     */
    public double[] inverseDeltaTransform(double[] uvw)
            throws UnsupportedOperationException;
}
